SUBDIRS=$$unique(SUBDIRS)

## Сокращаем SUBDIRS до списка приложений, затем разворачиваем по системе зависимостей

PROOUT="$${OUT_PWD}/.npk/dump"
PRODEST="$${PROOUT}/$$basename(_PRO_FILE_)"
RESULT="$${OUT_PWD}/subdirs-$$basename(_PRO_FILE_).pri"

ROOTDIR="$${_PRO_FILE_PWD_}"

# Заглушка sources.pri
write_file($${OUT_PWD}/sources.pri)





STACKPRO=""
LISTPRO=""

defineReplace(tabs) {
STR=""
for(i, 1..$$size(STACKPRO)) : STR=" $$STR"
return("$$STR")
}

defineTest(writeMainPri) {
    TAB="$$tabs()"
    for(i, ARGS) : PROTEXT += "$${TAB}$$i"
    export(PROTEXT)
}
#PROTEXT
defineTest(writeSubdirsPri) {
    TAB="$$tabs()"
    for(i, ARGS) : PROTEXT += "$${TAB}MSTR += \"$$i\""
    export(PROTEXT)
}

defineTest(writeCachePri) {
    TAB="$$tabs()"
    PROTEXT += "$${TAB}CSTR += \"$$ARGS\""
    export(PROTEXT)
}

defineTest(dumpSubdirs) {
 PARENTVAR=$$last(STACKPRO)
 PARENTVAR ~= s,/,_
 ARGS = $$unique(ARGS)
 for(proItem, ARGS) : !contains(proItem,.*$${LITERAL_HASH}.*) {
  proVar=$${proItem}
  proVar ~= s,/,_
  proName=$$split(proItem, /)
  proName="$${ROOTDIR}/$${proItem}/$$last(proName).pro"
  ! exists($$proName) {
        isEmpty(PARENTVAR) : PARENTVAR="$$basename(_PRO_FILE_)"
        error("Проект не найден: $$proName - получен при разборе depends.list проекта $$last(STACKPRO)")
  }
  DEPLIST="$$ROOTDIR/$${proItem}/depends.list"
  contains(STACKPRO, $$proItem) : error("Круговая зависимость: $${DEPLIST}, $$STACKPRO")

  writeMainPri("$$LITERAL_HASH $${proName} ---------------------")
  writeMainPri("CONFIG -= plugin")
  writeMainPri("QT_BAK = \$\$QT")
  writeMainPri($$cat($${proName}, blob))

  writeMainPri("$$LITERAL_HASH ---------------------")

  writeMainPri("for(item, SRCFILES) {")
  writeMainPri(" ITVAR=\$\$section(item, /, 0, 0)")
  writeMainPri(" eval(\$\${ITVAR}_$${proVar} = \$\$eval(\$\${ITVAR}))")
  writeMainPri(" eval(\$\${ITVAR} = \"\") ")
  writeMainPri("}")


  writeMainPri("for(item, LIST) { ")
  writeMainPri(" eval(\$\${item}_$${proVar} = \$\$eval(\$\$item))")
  writeMainPri(" eval(\$\${item} = \"\")")
  writeMainPri("}")

  writeMainPri("QT=\$\${QT_BAK}")
  writeMainPri("$$LITERAL_HASH ---------------------")

  isEmpty(STACKPRO) : writeMainPri("equals(TEMPLATE, app) {")
  STACKPRO += $$proItem
  export(STACKPRO)

  ! isEmpty(PARENTVAR) : writeSubdirsPri("$${PARENTVAR}.depends += \"$${proVar}\" " )
  LISTPRO += $$proVar


  # Для необработанных библиотек делаем кэш зависимостей

  TYPEPRO="TYPE_$$proVar"

  writeMainPri("$$TYPEPRO=\"\$\$TEMPLATE\"")
  writeMainPri("CONFIG(plugin) : $$TYPEPRO=\"plugin\"")
  ! isEmpty(PARENTVAR) {
  PREVTYPE="TYPE_$${PARENTVAR}"
  writeMainPri("equals($$TYPEPRO, app) : error(Приложение не должно быть подключено как зависимость! $$proItem)")
  writeMainPri("equals($$TYPEPRO, plugin) : ! equals($$PREVTYPE, app) : error(Плагин должен быть подключен только к приложению! $$proItem)")
  writeMainPri("PARENTTYPE=\"$${TYPEPRO}\"")
  writeMainPri("PARENTTYPE=\"\$\$eval(\$\$PARENTTYPE)\"")
  writeMainPri("eval(\"dep_\$\${PARENTTYPE}_$${PARENTVAR} *= \\\"$${proItem}\\\"\")")
  }


  writeMainPri("! contains(LISTPRO, $$proItem) {" "LISTPRO += $${proItem}")
  writeSubdirsPri("$${proVar}.file = \\\"$${proName}\\\"") ## \\\"\\\$\\\${_PRO_FILE_PWD_}/$${proItem}\\\"
  writeMainPri("}")

  exists($$DEPLIST) : dumpSubdirs($$cat($$DEPLIST, lines))

  STACKPRO -= $$proItem
  export(STACKPRO)

  # writeMainPri("generatePri($$proItem)")

  isEmpty(STACKPRO) : writeMainPri("}")
  }
}

#write_file($$RESULT, ARGS, append)"
PROTEXT="MSTR=\"\" " \
    "LISTPRO=\"\" " \
    "write_file($$RESULT, MSTR)" \
    " " \
    "LIST=QT LIBS INCLUDEPATH DEPENDPATH" \
    "SRCFILES=SOURCES/QMAKE_EXT_CPP HEADERS/QMAKE_EXT_H FORMS/QMAKE_EXT_UI" \
    "QT_BAK=\$\$QT" \
    " " \
    "defineReplace(priName) { " \ # Получение имени кэша
    "OUTPATH=\"$${OUT_PWD}/\$\$1\"" \
    "SRCPATH=\"$${ROOTDIR}/\$\$1\"" \
    "PRINAME="\$\$1"" \
    "PRINAME ~= s,/,_," \
    "return(\"\$\${OUTPATH}/cache-\$\${PRINAME}.pri\") " \
    " }" \
    " " \
    "defineTest(generatePri) { " \
    "OUTPATH=\"$${OUT_PWD}/\$\$1\"" \
    "SRCPATH=\"$${ROOTDIR}/\$\$1\"" \
    "PRINAME="\$\$1"" \
    "PRINAME ~= s,/,_," \
    "PRI=\"\$\$priName(\$\$1)\" " \
    "SRCPRI=\"\$\${OUTPATH}/files.pri\" " \
    " " \
    "STR=\"\" " \
    "USERFOUND=\"\" " \ # найдена хотя бы одна заполненная пользователем переменная - files.pri не будет создан
    "for(item, SRCFILES) : isEmpty(USERFOUND) {"\
    " ITVAR=\$\$section(item, /, 0, 0)" \
    " ITEXT=\$\$section(item, /, 1, 1)" \
    " ITVAL=\$\$eval(\$\${ITVAR}_\$\$PRINAME)" \
    " ! isEmpty(ITVAL) {" \
    "  USERFOUND=\"yes\" " \ # найдено, выход
    " } else {" \
    "  EXTLIST=\$\$eval(\$\$ITEXT) " \
    "  FOUNDFILES=\"\" " \
    "  for(ext, EXTLIST) : FOUNDFILES += \$\$files($${ROOTDIR}/\$\$1/src/*\$\${ext}, true)" \
    " " \
    "  isEmpty(FOUNDFILES) { " \ # ничего не нашли, зануляем переменную
    "   eval(\$\${ITVAR} = \"\")" \
    "  } else { " \
    "   STR+= \" \" \\ " \
    "   \"\$\${ITVAR} *= \\ \"" \
    "   for(absItem, FOUNDFILES) { " \
    "    item = \"\$\$relative_path(\$\$absItem, \$\$SRCPATH)\" " \
    " " \
    " " \ # При наличии пробелов снабжаем кавычками
    "    count(item, 1) { " \
    "     STR += \"\$\$item \\ \"" \
    "    } else { " \
    "     STR += \"\\\"\$\$item\\\" \\ \"" \
    "    }" \ # // count
    " " \
    "   }" \ # // for absItem
    "  }" \ # // isEmpty FOUNDFILES
    " eval(export(\$\${ITVAR}))" \
    " }" \ # // ! isEmpty ITVAL
    "}" \
    " " \
    " isEmpty(STR) || !isEmpty(USERFOUND) { " \ # Убираем пустой files.pri, или конфликтующий со старой версией
    " exists(\$\${SRCPRI}) : system($$QMAKE_DEL_FILE \"\$\${SRCPRI}\")" \
    " } else { " \
    "  STR=\"\$\$LITERAL_HASH Если этот файл не пуст, скопируйте его содержимое в главный проект \$\$SRCPATH\" \\ " \
    "  \$\${STR} " \
    "  write_file(\$\${SRCPRI}, STR) " \
    " } " \
    " " \
    "STR=\" \" " \
    " write_file(\$\$PRI, STR) " \
    "for(item, LIST) { " \
    " STR= \" \" \\ " \
    " \"\$\$item *= \\ \"" \
    " write_file(\$\$PRI, STR, append) " \
    " FILELINES=\$\$eval(\$\${item}_\$\${PRINAME}) " \
    " FILELINES=\$\$unique(FILELINES) " \
    " for(line, FILELINES) { " \
    " count(line, 1) {" \
    " STR=\"\$\$line \\ \" " \
    " } else {" \
    " STR=\"\\\"\$\$line\\\" \\ \" " \
    " }" \
    " write_file(\$\$PRI, STR, append) " \
    "  }" \
    " }" \
    "STR= \" \" " \
    "write_file(\$\$PRI, STR, append) " \
    " " \
    " " \ # рекурсивное подключение других кэшей
    " LISTDEPS = \$\$eval(dep_lib_\$\${PRINAME})" \ #    " CURPLUGINS += \$\$eval(dep_plugin_\$\${PRINAME})" \
    " for(item, LISTDEPS) { " \
    " PRI_CACHE=\"\$\$priName(\$\$item)\" " \
    " PRONAME = \$\$split(item, /) " \
    " PRONAME = \$\$last(PRONAME) " \
    " SRCPATH = \"$${ROOTDIR}/\$\$item/src\" " \
    " STR= \"! include(\\\"\$\$PRI_CACHE\\\") : error(Невозможно подключить \$\$PRI_CACHE) \" \\ " \
    " \"LIBS *= -l\$\$lower(\$\$PRONAME)\" \\ " \
    " \"INCLUDEPATH *= \\\"\$\${SRCPATH}\\\"\" \\ " \
    " \"DEPENDPATH *= \\\"\$\${SRCPATH}\\\"\" " \
    " write_file(\$\$PRI, STR, append) " \
    " }" \
    " " \
    "for(item, LIST) { " \
    " STR= \"export(\$\$item)\"" \
    " write_file(\$\$PRI, STR, append) " \
    " }" \
    " " \
    "}" \
    " " \

# Ждём QT 5.8, а там уже будет готовый sorted
lessThan(QT_MAJOR_VERSION, 6) : lessThan(QT_MINOR_VERSION, 8) {
PROTEXT += \
"defineReplace(sortHelper) { " \
"    START=\$\$first(ARGS) " \
"    LESSCOUNTER=\$\$START " \
"    LESSVALUE=\$\$member(ARGS, \$\$START) " \
"    for(j, \$\${START}..\$\$size(ARGS)) : lessThan(j, \$\$size(ARGS)) { " \
"        CURRENT=\"\$\$member(ARGS, \$\$j)\" " \
"        lessThan(CURRENT, \$\$LESSVALUE) { " \
"            LESSCOUNTER=\$\$j " \
"            LESSVALUE=\"\$\$CURRENT\" " \
"        } " \
"    } " \
" " \
"    RETURNVAL = \"\" " \
"    for(j, 1..\$\$size(ARGS)) { " \
"        equals(j, \$\$START) : RETURNVAL += \"\$\$LESSVALUE\" " \
"        ! equals(j, \$\$LESSCOUNTER) : RETURNVAL += \$\$member(ARGS, \$\$j) " \
"     } " \
"    return(\$\$RETURNVAL) " \
"} " \
" " \
"defineReplace(sorted) { " \
"    defined(\$\$ARGS, var) { " \
"    LIST=\$\$eval(\$\$ARGS) " \
"    for(i, 1..\$\$size(LIST)) : LIST = \$\$sortHelper(\$\$i \$\$LIST) " \
"    return(\$\$LIST) " \
"    }" \
"} " \
}

PROTEXT += "$$LITERAL_HASH ============================================= "

for (varName, SUBDIRS) {
# Получаем группу проекта по названию переменной

# Группа - подстрока до первого подчерка
    projectGroup = $$section(varName, _, 0, 0)

# Название проекта - остаток строки после первого подчерка
    projectName = $$varName
    projectName ~= s,^$${projectGroup}_,,

    dumpSubdirs($${projectGroup}/$${projectName})
}
#            " STR=\"$$varName\" " \
#            " write_file($$RESULT, STR, append) " \


PROTEXT += "$$LITERAL_HASH ============================================= "

PROTEXT += \
    " RESOURCES = " \
    " " \
    " for(item, LISTPRO) : generatePri(\$\$item)" \
    " LISTPRO ~= s,/,_,g " \
    " WRITESTR=\"SUBDIRS = \\\\ \" " \
    " LISTPRO=\$\$sorted(LISTPRO) " \
    " MSTR=\$\$unique(MSTR) " \
    " for(item, LISTPRO) : WRITESTR+=\"\$\$item \\\\ \" " \
    " WRITESTR+=\" \" \\ " \
    " \$\$sorted(MSTR) \\ " \
    " \" \" \\ " \
    " \"export(SUBDIRS)\" " \
    " write_file($$RESULT, WRITESTR, append) "

write_file($$PRODEST, PROTEXT) {
  ! system("$${QMAKE_QMAKE} -Wnone -o \"$$PROOUT/Makefile\" \"$$PRODEST\"") {
      error("Не удалось выполнить qmake $$PRODEST")
  }
} else : error("Не удалось записать файл $$PRODEST")

#for(item, SUBDIRS) : message($$item)

#SUBDIRS = ""


include($$RESULT)

# Отладка
#OTHER_FILES += $$PRODEST



#message(----------------------------)
#for(item, SUBDIRS) : message($$item)

export (SUBDIRS)

#qmakeforce.target=dummy
#qmakeforce.commands=$${QMAKE_DEL_FILE} -v $$files($${OUTPATH}/Makefile, true)
#qmakeforce.depends=FORCE

#PRE_TARGETDEPS += $$qmakeforce.target
#QMAKE_EXTRA_TARGETS += qmakeforce
#export(PRE_TARGETDEPS)
#export(QMAKE_EXTRA_TARGETS)

