#include "channel_finder.h"

#include <QDir>
#include <QRegExp>
#include "mil1553ud_library.h"

QStringList ChannelFinder::getChannelList()
{
    QDir dev("/dev");
    QStringList allFiles = dev.entryList(QDir::System);
    QRegExp rx("mil1553dev-(\\d+)-ch-(\\d+)");
    // обыскать каталог dev и найти паттерны mil1553dev-N-ch-M
    QStringList channels;
    foreach (QString fileName, allFiles) {
        if (rx.exactMatch(fileName)) {
            channels.append(QString("/dev/%1").arg(fileName));
        }
    }
    return channels;
}

QVector<ChannelFinder::ChannelInfo> ChannelFinder::getChannelInfoList()
{
    QVector<ChannelFinder::ChannelInfo> infoChannels;
    QStringList channels = getChannelList();
    foreach (QString fileName, channels) { // запросить у каналов их pciLocation
        int dev = open(fileName.toLatin1().constData(), O_RDWR);
        PCI_LOCATION pciLoc; // pci локация
        ioctl(dev, IOCTL_PCI_LOCATION, &pciLoc);
        ChannelFinder::ChannelInfo info;
        info.m_name = fileName;
        info.m_pciLocation = QString::fromLatin1(pciLoc.name, SIZE_OF_PCI_LOC);
        infoChannels.append(info);
        close(dev);
    }
    return infoChannels;
}

QString ChannelFinder::ChannelInfo::toString()
{
    // перевод role в строковое значение
    return QString("%1 (%2)").arg(m_name).arg(m_pciLocation);
}
