#ifndef CHANNEL_FINDER_H
#define CHANNEL_FINDER_H

#include <QObject>
#include <QStringList>
#include <QVector>

///
/// \brief The ChannelFinder class поисковик каналов
///
class ChannelFinder
{
public:
    ///
    /// \brief The ChannelInfo struct информация о канале
    ///
    struct ChannelInfo {
        /// \brief m_name полное имя канала
        QString m_name;
        /// \brief m_pciLocation информация об адресе pci
        QString m_pciLocation;

        /// \brief toString строковое имя
        /// \return строка
        QString toString();
    };

    /// \brief getChannelList получить список имён каналов
    /// \return список имён каналов
    static QStringList getChannelList();
    /// \brief getChannelInfoList получить список с информацией о каналах
    /// \return список с информацией о каналах
    static QVector<ChannelInfo> getChannelInfoList();
};

#endif // CHANNEL_FINDER_H
