#! /bin/bash

# Вывод ошибки, ожидание клавиши
showError() {
	>&2 printf "Error: $@\n"
	read -n1 -rsp $'Press any key to continue or Ctrl+C to exit...\n'
	exit 1
}

TOPDIR="`git rev-parse --show-toplevel`"
[ -z "$TOPDIR" ] && showError "Not in local repository path"

cd "$TOPDIR"

# Получаем название сервера
SERVER_NAME=`git config --get remote.origin.url | sed 's/.*@//g;s/:.*//g'`
[ -z "$SERVER_NAME" ] && showError "Empty repository name"

# Получаем скрипты системы сборки
git archive --remote=git@${SERVER_NAME}:developers/BuildSystem.git master | tar -C ../.. -xv

#Выполняем стандартный скрипт из корня папки
CONFSCRIPT="../../dev-configure.sh"
[[ ! -x $CONFSCRIPT ]] && showError "Not found: $CONFSCRIPT" && exit 1
./${CONFSCRIPT}

exit 0
