# Система сборки 2.0
# Автор: Ступаков М.С.
#
# Как это работает:
# Данная система делает дополнительный разбор pro-файлов с помощью QMAKE - это позволяет извлечь наиболее полные значения
# переменных QT, LIBS, INCLUDEPATH, DEPENDPATH, SOURCES, HEADERS.
# В выходном каталоге сборки (см. Проекты/Каталог сборки) создаётся набор необходимых файлов:
# 1. имяпроекта.pro - мета-файл, рекурсивно составленный из проектов
#      согласно дереву зависимостей (depends.list), обеспечивающий генерирование кеша и исходников (п.2).
# 2

# Преимущества такого подхода:
# - Если наша библиотека зависит от модуля QT или некоторой системной библиотеки, в вышестоящих проектах их можно не указывать.
# -



# Корень сборки
CACHEPATH="$$OUT_PWD/.npk"

# system($${QMAKE_DEL_TREE} "$$system_path($$CACHEPATH)")

OUTPATH=$$dirname(OUT_PWD)
OUTPATH=$$dirname(OUTPATH)

PROJ="$$dirname(_PRO_FILE_)"

GROUP="$$dirname(PROJ)"
ROOTDIR="$$dirname(GROUP)"

GROUP="$$basename(GROUP)"
PROJ="$$basename(PROJ)"


OWN_PATH="$$GROUP/$$PROJ"
verbose : message(qmake: $$OWN_PATH)

PRONAME="$$basename(_PRO_FILE_)"

! equals(PRONAME, "$${PROJ}.pro") : error("Названия каталога и pro-файла не совпадают! $$PRONAME != $$PROJ.pro, $$_PRO_FILE_, $$_PRO_FILE_PWD_")

TARGET = $$lower($$PROJ)

CONFIG(release, debug|release) : BUILDDIR = $$ROOTDIR/build/release
CONFIG(debug, debug|release) : BUILDDIR = $$ROOTDIR/build/debug

LIBSDIR = $$BUILDDIR
unix : LIBSDIR = $$BUILDDIR/libs

PLUGINSDIR = $$BUILDDIR/plugins

# Получаем место назначения исходного pro-файла
PRODEST="$${OUT_PWD}/$${PROJ}.pro"

PREVLIBSFILE="$${CACHEPATH}/LIBS.txt"

exists($$_PRO_FILE_PWD_/depends.list) : include($$_PRO_FILE_PWD_/depends.list)

PRINAME=$$OWN_PATH
PRINAME ~= s,/,_

PRI="$${OUT_PWD}/cache-$${PRINAME}.pri"
SRCPRI="$${OUT_PWD}/files.pri"
! exists($$PRI) : error("Не собран $$PRI")

#include($$PRI) #- отладка
LIST = QT LIBS INCLUDEPATH DEPENDPATH
for(item, LIST) : eval("$$item = $$fromfile($$PRI, $$item)")

exists("$$SRCPRI") : include("$$SRCPRI")

# Распределение вывода компилятора
OBJECTS_DIR = .obj
MOC_DIR = .moc
RCC_DIR = .qrc
UI_DIR = .ui
export(OBJECTS_DIR)
export(MOC_DIR)
export(RCC_DIR)
export(UI_DIR)

exists("$${PREVLIBSFILE}") {
    PREVLIBS=$$cat("$${PREVLIBSFILE}", lines)
    ! equals(LIBS, $$PREVLIBS) : system($${QMAKE_DEL_TREE} "$$system_path($$OUT_PWD/$$OBJECTS_DIR)" "$$system_path($$OUT_PWD/$$MOC_DIR)")

}
write_file("$${PREVLIBSFILE}", LIBS)

qmakeforce.target=dummy
qmakeforce.commands="$${QMAKE_DEL_FILE} -v $$files(\"$${OUTPATH}/Makefile\", true)"
qmakeforce.depends=FORCE

PRE_TARGETDEPS += $$qmakeforce.target
QMAKE_EXTRA_TARGETS += qmakeforce
export(PRE_TARGETDEPS)
export(QMAKE_EXTRA_TARGETS)

equals(TEMPLATE, lib) {
 CONFIG(plugin) {
 target.path = $$PLUGINSDIR
} else {
 target.path = $$LIBSDIR
 CONFIG += dll
}
}

equals(TEMPLATE, app) {
    DESTDIR = $$BUILDDIR
    target.path = "$$OUT_PWD"

    unix {
    QMAKE_LFLAGS += "-Wl,-rpath,\'\$$ORIGIN/libs\'"
    }
}
INSTALLS += target

LIBS *= -L$$LIBSDIR
INCLUDEPATH *= "$${_PRO_FILE_PWD_}/src" \
"$${_PRO_FILE_PWD_}/src-private"

verbose : for(item, LIST) : message($$TARGET : $$item : $$eval($$item))

export(QT)
export(LIBS)
export(INCLUDEPATH)
export(DEPENDPATH)
export(HEADERS)
export(SOURCES)
export(FORMS)


# Принудительно включаем C++11
#greaterThan(QT_MAJOR_VERSION, 4){
#CONFIG += c++11
#} else {
#QMAKE_CXXFLAGS += -std=c++0x
#}

CONFIG+=hide_symbols
export(CONFIG)

export(target)
