#! /bin/bash

# Вывод ошибки, ожидание клавиши
showError() {
	>&2 printf "$@"
	read -n1 -rsp $'Press any key to continue or Ctrl+C to exit...\n'
}

# Получаем название сервера
SERVER_NAME=`git config --get remote.origin.url | sed 's/.*@//g;s/:.*//g'`
if [ -z "$SERVER_NAME" ]
then
	showError "Empty repository name"
	exit 1
fi

# Получаем скрипты системы сборки
git archive --remote=git@${SERVER_NAME}:developers/BuildSystem.git master | tar -C ../../.. -xv

#Выполняем стандартный скрипт из корня папки
CONFSCRIPT="../../../dev-configure.sh"
[[ ! -x $CONFSCRIPT ]] && showError "Not found: $CONFSCRIPT" && exit 1
./${CONFSCRIPT}

exit 0
